//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "ADAMEm.h"
#include "ADAMEmMamMain.h"
#include "ADAMEmMamAboutBox.h"
#include "ADAMEmMamReadMe.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
#pragma codestring "This executable copyright (C) M. de Kogel, 1997"
#include <vcl/inifiles.hpp>
#include <dir.h>

#define Section		"ADAMEmMam"		// ini file section

TADAMEmMamMainForm *ADAMEmMamMainForm;
//---------------------------------------------------------------------------
__fastcall TADAMEmMamMainForm::TADAMEmMamMainForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TADAMEmMamMainForm::AboutButtonClick(TObject *Sender)
{
 TAboutBox *aboutBox=new TAboutBox(this);
 aboutBox->ShowModal();
 delete aboutBox;
}
//---------------------------------------------------------------------------
void __fastcall TADAMEmMamMainForm::OpenButtonClick(TObject *Sender)
{
 if (Sender==ADAMEmPathButton)
 {
  OpenDialogue->DefaultExt="exe";
  OpenDialogue->Filter="Applications|*.exe|";
 }
 else if (Sender==CassetteAButton || Sender==CassetteBButton)
 {
  OpenDialogue->DefaultExt="cas";
  OpenDialogue->Filter="Cassette images|*.cas|";
 }
 else if (Sender==CartridgeButton || Sender==EOSButton || Sender==WPButton || Sender==OS7Button)
 {
  OpenDialogue->DefaultExt="rom";
  OpenDialogue->Filter="ROM images|*.rom|";
 }
 else if (Sender==DiskAButton || Sender==DiskBButton ||
 		  Sender==DiskCButton || Sender==DiskDButton)
 {
  OpenDialogue->DefaultExt="dsk";
  OpenDialogue->Filter="Disk images|*.dsk|";
 }
 else if (Sender==PrinterLogButton)
 {
  OpenDialogue->DefaultExt="prn";
  OpenDialogue->Filter="Raw printer data|*.prn|";
 }
 else if (Sender==ParallelLogButton)
 {
  OpenDialogue->DefaultExt="prn";
  OpenDialogue->Filter="Raw printer data|*.prn|";
 }
 else if (Sender==SoundLogButton)
 {
  OpenDialogue->DefaultExt="snd";
  OpenDialogue->Filter="Sound log files|*.snd|";
 }
 else if (Sender==SnapButton)
 {
  OpenDialogue->DefaultExt="snp";
  OpenDialogue->Filter="Snapshots|*.snp|";
 }
 else if (Sender==StartupDirectoryButton)
 {
  OpenDialogue->DefaultExt="";
  OpenDialogue->Filter="";
 }
 OpenDialogue->Filter+="All files|*.*";
 OpenDialogue->FilterIndex=0;
 OpenDialogue->HistoryList->Clear();
 OpenDialogue->FileName="";
 if (!OpenDialogue->Execute())
  return;
 if (Sender==ADAMEmPathButton)
  ADAMEmPathEdit->Text=ADAMEm->ADAMEmPath=OpenDialogue->FileName;
 else if (Sender==CassetteAButton)
  CassetteAEdit->Text=ADAMEm->CassetteAImage=OpenDialogue->FileName;
 else if (Sender==CassetteBButton)
  CassetteBEdit->Text=ADAMEm->CassetteBImage=OpenDialogue->FileName;
 else if (Sender==DiskAButton)
  DiskAEdit->Text=ADAMEm->DiskAImage=OpenDialogue->FileName;
 else if (Sender==DiskBButton)
  DiskBEdit->Text=ADAMEm->DiskBImage=OpenDialogue->FileName;
 else if (Sender==DiskCButton)
  DiskCEdit->Text=ADAMEm->DiskCImage=OpenDialogue->FileName;
 else if (Sender==DiskDButton)
  DiskDEdit->Text=ADAMEm->DiskDImage=OpenDialogue->FileName;
 else if (Sender==CartridgeButton)
  CartridgeEdit->Text=ADAMEm->CartridgeImage=OpenDialogue->FileName;
 else if (Sender==SoundLogButton)
  SoundLogEdit->Text=ADAMEm->SoundLog=OpenDialogue->FileName;
 else if (Sender==SnapButton)
  SnapEdit->Text=ADAMEm->Snapshot=OpenDialogue->FileName;
 else if (Sender==PrinterLogButton)
  PrinterLogEdit->Text=ADAMEm->PrinterLog=OpenDialogue->FileName;
 else if (Sender==ParallelLogButton)
  ParallelLogEdit->Text=ADAMEm->ParallelLog=OpenDialogue->FileName;
 else if (Sender==EOSButton)
  EOSEdit->Text=ADAMEm->EOSImage=OpenDialogue->FileName;
 else if (Sender==OS7Button)
  OS7Edit->Text=ADAMEm->EOSImage=OpenDialogue->FileName;
 else if (Sender==WPButton)
  WPEdit->Text=ADAMEm->EOSImage=OpenDialogue->FileName;
 else if (Sender==StartupDirectoryButton)
 {
  char drive[MAXDRIVE];
  char dir[MAXDIR];
  fnsplit (OpenDialogue->FileName.c_str(),drive,dir,NULL,NULL);
  AnsiString ansiString=AnsiString(drive);
  ansiString+=AnsiString(dir);
  StartupDirectoryEdit->Text=ADAMEm->StartupDirectory=ansiString;
 }
}
//---------------------------------------------------------------------------
void __fastcall TADAMEmMamMainForm::StringEditExit(TObject *Sender)
{
 TEdit *edit=(TEdit*)Sender;
 AnsiString &s=edit->Text;
 if (Sender==ADAMEmPathEdit)
  ADAMEm->ADAMEmPath=s;
 else if (Sender==CassetteAEdit)
  ADAMEm->CassetteAImage=s;
 else if (Sender==CassetteBEdit)
  ADAMEm->CassetteBImage=s;
 else if (Sender==DiskAEdit)
  ADAMEm->DiskAImage=s;
 else if (Sender==DiskBEdit)
  ADAMEm->DiskBImage=s;
 else if (Sender==DiskCEdit)
  ADAMEm->DiskCImage=s;
 else if (Sender==DiskDEdit)
  ADAMEm->DiskDImage=s;
 else if (Sender==CartridgeEdit)
  ADAMEm->CartridgeImage=s;
 else if (Sender==SoundLogEdit)
  ADAMEm->SoundLog=s;
 else if (Sender==PrinterLogEdit)
  ADAMEm->PrinterLog=s;
 else if (Sender==ParallelLogEdit)
  ADAMEm->ParallelLog=s;
 else if (Sender==SnapEdit)
  ADAMEm->Snapshot=s;
 else if (Sender==EOSEdit)
  ADAMEm->EOSImage=s;
 else if (Sender==WPEdit)
  ADAMEm->WPImage=s;
 else if (Sender==OS7Edit)
  ADAMEm->OS7Image=s;
 else if (Sender==StartupDirectoryEdit)
  ADAMEm->StartupDirectory=s;
}
//---------------------------------------------------------------------------
void __fastcall TADAMEmMamMainForm::RadioGroupClick(TObject *Sender)
{
 TRadioGroup *radioGroup=(TRadioGroup*)Sender;
 int index=radioGroup->ItemIndex;
 if (Sender==VideoModeRadioGroup)
  ADAMEm->VideoMode=index;
 else if (Sender==EmulationModeRadioGroup)
  ADAMEm->EmuMode=index;
 else if (Sender==PrinterTypeRadioGroup)
  ADAMEm->PrinterType=index;
 else if (Sender==JoystickRadioGroup)
  ADAMEm->Joystick=index;
 else if (Sender==TDOSRadioGroup)
  ADAMEm->TDOSVideoMode=index;
 else if (Sender==PaletteRadioGroup)
  ADAMEm->Palette=index;
}
//---------------------------------------------------------------------------
void __fastcall TADAMEmMamMainForm::RadioButtonClick(
	TObject *Sender)
{
 TRadioButton *radioButton=(TRadioButton*)Sender;
 bool checked=radioButton->Checked;
 if (Sender==ExpansionMouseRadioButton)
  ADAMEm->ExpansionModuleDevice=(checked)? 0:1;
 else if (Sender==ExpansionJoystickRadioButton)
  ADAMEm->ExpansionModuleDevice=(checked)? 1:0;
}
//---------------------------------------------------------------------------
void __fastcall TADAMEmMamMainForm::CheckBoxClick(TObject *Sender)
{
 TCheckBox *checkBox=(TCheckBox*)Sender;
 bool checked=checkBox->Checked;
 if (Sender==CalibrateCheckBox)
  ADAMEm->Calibrate=checked;
 else if (Sender==VerboseCheckBox)
  ADAMEm->Verbose=checked;
 else if (Sender==SyncCheckBox)
  ADAMEm->Sync=checked;
 else if (Sender==SwapJoystickButtonsCheckBox)
  ADAMEm->SwapJoystickButtons=checked;
 else if (Sender==SwapKeyboardButtonsCheckBox)
  ADAMEm->SwapKeyboardButtons=checked;
 else if (Sender==SwapMouseButtonsCheckBox)
  ADAMEm->SwapMouseButtons=checked;
 else if (Sender==ReverseKeypadCheckBox)
  ADAMEm->ReverseKeypad=checked;
 else if (Sender==OverscanCheckBox)
  ADAMEm->Overscan=checked;
 else if (Sender==ShowAllSpritesCheckBox)
  ADAMEm->ShowAllSprites=checked;
 else if (Sender==AutoSnapCheckBox)
  ADAMEm->AutoSnap=checked;
}
//---------------------------------------------------------------------------
#define EDIT(a)		a=value;value=a
void __fastcall TADAMEmMamMainForm::EditExit(TObject *Sender)
{
 TEdit *edit=(TEdit*)Sender;
 int value=atoi(edit->Text.c_str());
 if (Sender==VolumeEdit)
 { EDIT(ADAMEm->Volume); }
 else if (Sender==SoundQualityEdit)
 { EDIT(ADAMEm->SoundQuality); }
 else if (Sender==UPeriodEdit)
 { EDIT(ADAMEm->UPeriod); }
 else if (Sender==PanningLevelEdit)
 { EDIT(ADAMEm->PanningLevel); }
 else if (Sender==ReverbLevelEdit)
 { EDIT(ADAMEm->ReverbLevel); }
 else if (Sender==ChorusLevelEdit)
 { EDIT(ADAMEm->ChorusLevel); }
 else if (Sender==SpeakerChannelAEdit)
 { EDIT(ADAMEm->SpeakerChannelA); }
 else if (Sender==SpeakerChannelBEdit)
 { EDIT(ADAMEm->SpeakerChannelB); }
 else if (Sender==SpeakerChannelCEdit)
 { EDIT(ADAMEm->SpeakerChannelC); }
 else if (Sender==SpeakerChannelDEdit)
 { EDIT(ADAMEm->SpeakerChannelD); }
 else if (Sender==IFreqEdit)
 { EDIT(ADAMEm->IFreq); }
 else if (Sender==CPUSpeedEdit)
 { EDIT(ADAMEm->CPUSpeed); }
 else if (Sender==SensitivityEdit)
 { EDIT(ADAMEm->Sensitivity); }
 else if(Sender==ExpansionRAMEdit)
 { EDIT(ADAMEm->ExpansionRAMPages); };
 edit->Text=AnsiString(value);
}
#undef EDIT
//---------------------------------------------------------------------------
void __fastcall TADAMEmMamMainForm::ComboBoxChange(TObject *Sender)
{
 TComboBox *comboBox=(TComboBox*)Sender;
 int index=comboBox->ItemIndex;
 if (Sender==SoundComboBox)
  ADAMEm->SoundDevice=(index)? index-1:255;
 else if (Sender==ExpansionModuleComboBox)
  ADAMEm->ExpansionModule=index;
}
//---------------------------------------------------------------------------
void __fastcall TADAMEmMamMainForm::MainPageControlChange(TObject *Sender)
{
 static TTabSheet *OldTabSheet=PathsSheet;
 TPageControl *pageControl=(TPageControl*)Sender;
 UpdateTabSheet (OldTabSheet);
 OldTabSheet=pageControl->ActivePage;
 if (OldTabSheet==OptionsSheet)
  SetEmulatorOptions();
 else if (OldTabSheet==ReadMeSheet)
 {
  try
  {
   ADAMEmReadMeMemo->Lines->LoadFromFile(ADAMEm->ReadMeFile);
  }
  catch (Exception &exception)
  {
   ADAMEmReadMeMemo->Lines->Text="Cannot find ADAMEm.txt";
  }
 }
}
//---------------------------------------------------------------------------
void TADAMEmMamMainForm::UpdateTabSheet(TTabSheet *tabSheet)
{
 if (tabSheet==PathsSheet)
 {
  StringEditExit (ADAMEmPathEdit);
  StringEditExit (EOSEdit);
  StringEditExit (WPEdit);
  StringEditExit (OS7Edit);
  StringEditExit (StartupDirectoryEdit);
 }
 else if (tabSheet==ImagesSheet)
 {
  StringEditExit (CassetteAEdit);
  StringEditExit (CassetteBEdit);
  StringEditExit (DiskAEdit);
  StringEditExit (DiskBEdit);
  StringEditExit (DiskCEdit);
  StringEditExit (DiskDEdit);
  StringEditExit (CartridgeEdit);
  StringEditExit (SnapEdit);
 }
 else if (tabSheet==VideoSoundSheet)
 {
  EditExit (VolumeEdit);
  EditExit (SoundQualityEdit);
  EditExit (PanningLevelEdit);
  EditExit (ReverbLevelEdit);
  EditExit (ChorusLevelEdit);
  EditExit (SpeakerChannelAEdit);
  EditExit (SpeakerChannelBEdit);
  EditExit (SpeakerChannelCEdit);
  EditExit (SpeakerChannelDEdit);
  EditExit (UPeriodEdit);
  StringEditExit (SoundLogEdit);
 }
 else if (tabSheet==MiscSheet)
 {
  EditExit (IFreqEdit);
  EditExit (CPUSpeedEdit);
  EditExit (SensitivityEdit);
  EditExit (ExpansionRAMEdit);
  StringEditExit (PrinterLogEdit);
 }
 else if (tabSheet==UserSheet)
  MemoExit (UserOptionsMemo);
}
//---------------------------------------------------------------------------
void TADAMEmMamMainForm::UpdateAllOptions (void)
{
 UpdateTabSheet (PathsSheet);
 UpdateTabSheet (ImagesSheet);
 UpdateTabSheet (VideoSoundSheet);
 UpdateTabSheet (MiscSheet);
 UpdateTabSheet (UserSheet);
 UpdateTabSheet (OptionsSheet);
 UpdateTabSheet (ReadMeSheet);
}
//---------------------------------------------------------------------------
void TADAMEmMamMainForm::SetAllOptions(void)
{
 ADAMEmPathEdit->Text=ADAMEm->ADAMEmPath;
 EOSEdit->Text=ADAMEm->EOSImage;
 WPEdit->Text=ADAMEm->WPImage;
 OS7Edit->Text=ADAMEm->OS7Image;
 StartupDirectoryEdit->Text=ADAMEm->StartupDirectory;
 CassetteAEdit->Text=ADAMEm->CassetteAImage;
 CassetteBEdit->Text=ADAMEm->CassetteBImage;
 DiskAEdit->Text=ADAMEm->DiskAImage;
 DiskBEdit->Text=ADAMEm->DiskBImage;
 DiskCEdit->Text=ADAMEm->DiskCImage;
 DiskDEdit->Text=ADAMEm->DiskDImage;
 CartridgeEdit->Text=ADAMEm->CartridgeImage;
 VideoModeRadioGroup->ItemIndex=ADAMEm->VideoMode;
 UPeriodEdit->Text=AnsiString(ADAMEm->UPeriod);
 OverscanCheckBox->Checked=ADAMEm->Overscan;
 ShowAllSpritesCheckBox->Checked=ADAMEm->ShowAllSprites;
 SoundComboBox->ItemIndex=(ADAMEm->SoundDevice==255)? 0 : (ADAMEm->SoundDevice+1);
 VolumeEdit->Text=AnsiString(ADAMEm->Volume);
 SoundQualityEdit->Text=AnsiString(ADAMEm->SoundQuality);
 PanningLevelEdit->Text=AnsiString(ADAMEm->PanningLevel);
 ReverbLevelEdit->Text=AnsiString(ADAMEm->ReverbLevel);
 ChorusLevelEdit->Text=AnsiString(ADAMEm->ChorusLevel);
 SpeakerChannelAEdit->Text=AnsiString(ADAMEm->SpeakerChannelA);
 SpeakerChannelBEdit->Text=AnsiString(ADAMEm->SpeakerChannelB);
 SpeakerChannelCEdit->Text=AnsiString(ADAMEm->SpeakerChannelC);
 SpeakerChannelDEdit->Text=AnsiString(ADAMEm->SpeakerChannelD);
 SoundLogEdit->Text=ADAMEm->SoundLog;
 EmulationModeRadioGroup->ItemIndex=ADAMEm->EmuMode;
 IFreqEdit->Text=ADAMEm->IFreq;
 CPUSpeedEdit->Text=ADAMEm->CPUSpeed;
 SnapEdit->Text=ADAMEm->Snapshot;
 ParallelLogEdit->Text=ADAMEm->ParallelLog;
 TDOSRadioGroup->ItemIndex=ADAMEm->TDOSVideoMode;
 PaletteRadioGroup->ItemIndex=ADAMEm->Palette;
 ExpansionRAMEdit->Text=AnsiString(ADAMEm->ExpansionRAMPages);
 ExpansionModuleComboBox->ItemIndex=ADAMEm->ExpansionModule;
 ExpansionMouseRadioButton->Checked=(ADAMEm->ExpansionModuleDevice==0);
 ExpansionJoystickRadioButton->Checked=(ADAMEm->ExpansionModuleDevice==1);
 SensitivityEdit->Text=AnsiString(ADAMEm->Sensitivity);
 CalibrateCheckBox->Checked=ADAMEm->Calibrate;
 VerboseCheckBox->Checked=ADAMEm->Verbose;
 SyncCheckBox->Checked=ADAMEm->Sync;
 PrinterTypeRadioGroup->ItemIndex=ADAMEm->PrinterType;
 JoystickRadioGroup->ItemIndex=ADAMEm->Joystick;
 SwapJoystickButtonsCheckBox->Checked=ADAMEm->SwapJoystickButtons;
 SwapKeyboardButtonsCheckBox->Checked=ADAMEm->SwapKeyboardButtons;
 SwapMouseButtonsCheckBox->Checked=ADAMEm->SwapMouseButtons;
 ReverseKeypadCheckBox->Checked=ADAMEm->ReverseKeypad;
 PrinterLogEdit->Text=ADAMEm->PrinterLog;
 UserOptionsMemo->Text=ADAMEm->UserOptions;
 SetEmulatorOptions();
}
//---------------------------------------------------------------------------
void TADAMEmMamMainForm::SetEmulatorOptions(void)
{
 AnsiString *s=new AnsiString;
 OptionsMemo->Text=ADAMEm->GetEmulatorOptions(*s);
 delete s;
}
//---------------------------------------------------------------------------

void __fastcall TADAMEmMamMainForm::FormCreate(TObject *Sender)
{
 char s[MAXPATH];
 char drive[MAXDRIVE];
 char dir[MAXDIR];
 fnsplit (Application->ExeName.c_str(),drive,dir,NULL,NULL);
 fnmerge (s,drive,dir,"ADAMEmMam",".txt");
 ReadMeFile=AnsiString(s);
 fnmerge (s,drive,dir,"ADAMEmMam",".ini");
 IniFile=AnsiString(s);
 try
 {
  ADAMEmMamReadMeMemo->Lines->LoadFromFile(ReadMeFile);
 }
 catch (Exception &exception)
 {
  ADAMEmMamReadMeMemo->Lines->Text="Cannot find ADAMEmMam.txt";
 }
 ADAMEm=new TADAMEm;
 ADAMEm->LoadFromFile(IniFile);
 TIniFile &iniFile=*new TIniFile(IniFile);
 AnsiString &a=iniFile.ReadString (Section,"cwd","");
 if (a.c_str()[0])
 {
  chdir (a.c_str());
  setdisk (tolower(a.c_str()[0])-'a');
 }
 else
  AboutButtonClick(this);
 Left=iniFile.ReadInteger (Section,"Left",Left);
 Top=iniFile.ReadInteger (Section,"Top",Top);
 switch (iniFile.ReadInteger (Section,"Page",0))
 {
  case 0:
   MainPageControl->ActivePage=PathsSheet;
   break;
  case 1:
   MainPageControl->ActivePage=ImagesSheet;
   break;
  case 2:
   MainPageControl->ActivePage=VideoSoundSheet;
   break;
  case 3:
   MainPageControl->ActivePage=MiscSheet;
   break;
  case 4:
   MainPageControl->ActivePage=UserSheet;
   break;
  case 5:
   MainPageControl->ActivePage=OptionsSheet;
   break;
  case 6:
   MainPageControl->ActivePage=ReadMeSheet;
   break;
 }
 delete &iniFile;
 SetAllOptions ();
 MainPageControlChange(MainPageControl);
}
//---------------------------------------------------------------------------
void __fastcall TADAMEmMamMainForm::FormDestroy(TObject *Sender)
{
 UpdateAllOptions();
 ADAMEm->SaveToFile(IniFile);
 delete ADAMEm;
 TIniFile &iniFile=*new TIniFile(IniFile);
 char s[MAXPATH];
 getcwd (s,sizeof(s));
 iniFile.WriteString (Section,"cwd",AnsiString(s));
 iniFile.WriteInteger (Section,"Left",Left);
 iniFile.WriteInteger (Section,"Top",Top);
 int Page=0;
 if (MainPageControl->ActivePage==PathsSheet) Page=0;
 else if (MainPageControl->ActivePage==ImagesSheet) Page=1;
 else if (MainPageControl->ActivePage==VideoSoundSheet) Page=2;
 else if (MainPageControl->ActivePage==MiscSheet) Page=3;
 else if (MainPageControl->ActivePage==UserSheet) Page=4;
 else if (MainPageControl->ActivePage==OptionsSheet) Page=5;
 else if (MainPageControl->ActivePage==ReadMeSheet) Page=6;
 iniFile.WriteInteger (Section,"Page",Page);
 delete &iniFile;
}
//---------------------------------------------------------------------------
void __fastcall TADAMEmMamMainForm::ReadMeButtonClick(TObject *Sender)
{
 TReadMeForm *readMeForm=new TReadMeForm(this);
 if (Sender==ADAMEmMamReadMeButton)
 {
  readMeForm->Caption="ADAMEmMam Read Me";
  readMeForm->ReadMeMemo->Lines=ADAMEmMamReadMeMemo->Lines;
 }
 else if (Sender==ADAMEmReadMeButton)
 {
  readMeForm->Caption="ADAMEm Read Me";
  readMeForm->ReadMeMemo->Lines=ADAMEmReadMeMemo->Lines;
 }
 readMeForm->ShowModal();
 delete readMeForm;
}
//---------------------------------------------------------------------------
void __fastcall TADAMEmMamMainForm::MemoExit(TObject *Sender)
{
 if (Sender==UserOptionsMemo)
  ADAMEm->UserOptions=UserOptionsMemo->Text;
}
//---------------------------------------------------------------------------
void __fastcall TADAMEmMamMainForm::DefaultButtonClick(TObject *Sender)
{
 ADAMEm->SetDefaultOptions();
 SetAllOptions();
}
//---------------------------------------------------------------------------
void __fastcall TADAMEmMamMainForm::LaunchButtonClick(TObject *Sender)
{
 UpdateAllOptions();
 ADAMEm->Execute();
}
//---------------------------------------------------------------------------
